diff --git a/client/main.c b/client/main.c
index 3f8143dde4b8..9258b44655dd 100644
--- a/client/main.c
+++ b/client/main.c
@@ -43,7 +43,7 @@
 #define COLORED_CHG	COLOR_YELLOW "CHG" COLOR_OFF
 #define COLORED_DEL	COLOR_RED "DEL" COLOR_OFF
 
-#define PROMPT_ON	"[bluetooth]# "
+#define PROMPT_ON	"[bluetoothctl]> "
 #define PROMPT_OFF	"Waiting to connect to bluetoothd..."
 
 static DBusConnection *dbus_conn;
@@ -333,7 +333,7 @@ static void set_default_device(GDBusProxy *proxy, const char *attribute)
 	path = g_dbus_proxy_get_path(proxy);
 
 	dbus_message_iter_get_basic(&iter, &desc);
-	desc = g_strdup_printf("[%s%s%s]# ", desc,
+	desc = g_strdup_printf("[%s%s%s]> ", desc,
 				attribute ? ":" : "",
 				attribute ? attribute + strlen(path) : "");
 
@@ -2099,7 +2099,7 @@ static void set_default_local_attribute(char *attr)
 	default_local_attr = attr;
 	default_attr = NULL;
 
-	desc = g_strdup_printf("[%s]# ", attr);
+	desc = g_strdup_printf("[%s]> ", attr);
 
 	bt_shell_set_prompt(desc, COLOR_BLUE);
 	g_free(desc);
diff --git a/client/mgmt.c b/client/mgmt.c
index 59dcb3135344..1946d65d2fe2 100644
--- a/client/mgmt.c
+++ b/client/mgmt.c
@@ -71,16 +71,16 @@ static int pending_index = 0;
 #define MIN(x, y) ((x) < (y) ? (x) : (y))
 #endif
 
-#define PROMPT_ON	COLOR_BLUE "[mgmt]" COLOR_OFF "# "
+#define PROMPT_ON	COLOR_BLUE "[mgmt]" COLOR_OFF "> "
 
 static void update_prompt(uint16_t index)
 {
 	char str[32];
 
 	if (index == MGMT_INDEX_NONE)
-		snprintf(str, sizeof(str), "[mgmt]# ");
+		snprintf(str, sizeof(str), "[mgmt]> ");
 	else
-		snprintf(str, sizeof(str), "[hci%u]# ", index);
+		snprintf(str, sizeof(str), "[hci%u]> ", index);
 
 	bt_shell_set_prompt(str, COLOR_BLUE);
 }
diff --git a/tools/bluetooth-player.c b/tools/bluetooth-player.c
index 83045ca3fe41..63a95b878fb8 100644
--- a/tools/bluetooth-player.c
+++ b/tools/bluetooth-player.c
@@ -33,7 +33,7 @@
 #include "src/shared/shell.h"
 #include "client/player.h"
 
-#define PROMPT	"[bluetooth]# "
+#define PROMPT	"[bluetooth-player]> "
 
 static DBusConnection *dbus_conn;
 
diff --git a/tools/btpclientctl.c b/tools/btpclientctl.c
index eb97463148d2..f6f61ed5d651 100644
--- a/tools/btpclientctl.c
+++ b/tools/btpclientctl.c
@@ -34,7 +34,7 @@
 
 #define DEFAULT_SOCKET_PATH	"/tmp/bt-stack-tester"
 
-#define PROMPT_ON	COLOR_BLUE "[btpclient]" COLOR_OFF "# "
+#define PROMPT_ON	COLOR_BLUE "[btpclient]" COLOR_OFF "> "
 
 #define EVT_OPCODE_BASE	0x80
 
diff --git a/tools/mesh-cfgclient.c b/tools/mesh-cfgclient.c
index e64950a9cc65..3bd2b673ad7f 100644
--- a/tools/mesh-cfgclient.c
+++ b/tools/mesh-cfgclient.c
@@ -38,7 +38,7 @@
 #include "tools/mesh/model.h"
 #include "tools/mesh/remote.h"
 
-#define PROMPT_ON	"[mesh-cfgclient]# "
+#define PROMPT_ON	"[mesh-cfgclient]> "
 #define PROMPT_OFF	"Waiting to connect to bluetooth-meshd..."
 
 #define CFG_SRV_MODEL	0x0000
diff --git a/tools/mesh-gatt/util.c b/tools/mesh-gatt/util.c
index 58f240a7748e..84fa7b5eedb0 100644
--- a/tools/mesh-gatt/util.c
+++ b/tools/mesh-gatt/util.c
@@ -29,7 +29,7 @@ void set_menu_prompt(const char *name, const char *id)
 {
 	char *prompt;
 
-	prompt = g_strdup_printf("[%s%s%s]# ", name,
+	prompt = g_strdup_printf("[%s%s%s]> ", name,
 					id ? ": Target = " : "", id ? id : "");
 	bt_shell_set_prompt(prompt, COLOR_BLUE);
 	g_free(prompt);
diff --git a/tools/mesh/util.c b/tools/mesh/util.c
index 310aae0c63e6..6e81bf5f0285 100644
--- a/tools/mesh/util.c
+++ b/tools/mesh/util.c
@@ -28,7 +28,7 @@ void set_menu_prompt(const char *name, const char *id)
 {
 	char *prompt;
 
-	prompt = l_strdup_printf("[%s%s%s]# ", name,
+	prompt = l_strdup_printf("[%s%s%s]> ", name,
 					id ? ": Target = " : "", id ? id : "");
 	bt_shell_set_prompt(prompt, COLOR_BLUE);
 	l_free(prompt);
diff --git a/tools/meshctl.c b/tools/meshctl.c
index 00a68a3d1d57..7b9c44b11e49 100644
--- a/tools/meshctl.c
+++ b/tools/meshctl.c
@@ -54,7 +54,7 @@
 #define COLORED_CHG	COLOR_YELLOW "CHG" COLOR_OFF
 #define COLORED_DEL	COLOR_RED "DEL" COLOR_OFF
 
-#define PROMPT_ON	"[meshctl]# "
+#define PROMPT_ON	"[meshctl]> "
 #define PROMPT_OFF	"Waiting to connect to bluetoothd..."
 
 #define MESH_PROV_DATA_IN_UUID_STR	"00002adb-0000-1000-8000-00805f9b34fb"
@@ -603,7 +603,7 @@ static void set_connected_device(GDBusProxy *proxy)
 			goto done;
 
 	dbus_message_iter_get_basic(&iter, &desc);
-	desc = g_strdup_printf(COLOR_BLUE "[%s%s%s]" COLOR_OFF "# ", desc,
+	desc = g_strdup_printf(COLOR_BLUE "[%s%s%s]" COLOR_OFF "> ", desc,
 			       (desc && mesh) ? "-" : "",
 				mesh ? buf : "");
 